//Header de la classe CPerso

#include "CSpritesPerso.h"
#include "Define.h"

class CPerso
{
	protected:
		int PosX, PosY, PosXLastDepl, PosYLastDepl;
		int Etat, TypeIA;
		Uint32 DebutAnim, DebutAnimDegat, FinAnimDegat, TimeLastDepl;

		int LastCalcDepl;
		
		CSpritesPerso* RenderPerso;

		bool VersLaDroite, Principal;

		bool TouchesAppuyee[6];

		double VitX, VitY;

		int LastSaut, DebutMort, HauteurMax;
		
		//Pts de vie
		int Vie, VieMax;
		//Pts de mana
		int Mana, ManaMax;
	
		int DejaPasser;
	

	public:

		CPerso();
		~CPerso();

		void CalcIA();
		bool IASuivrePerso();
		void DessinePerso();
		void ModifPos(int X, int Y);
		void ModifTouche(int Touche, bool Appuyee);
		inline bool DroitAcces(int px, int py);
		inline bool MortSiAcces(int px, int py);
		void TexPerso(const char *nom);
		void CalcDepl();
		void SetIA(int newIA);
		void SetIA(string stria);
		void PerteVie(int vieenmoin);
		void AnimDegat(int time = 300);
		bool CampAllie();
		int ReturnIA();
		int ReturnPosX();
		int ReturnPosY();
		int ReturnEtat();
		bool ReturnVersLaDroite();
		int ReturnVie();
		int ReturnVieMax();
		int ReturnMana();
		int ReturnManaMax();
		bool ReturnTouche(int touche);
		void DeintDejaPasser();
		void GainVie(int VieEnPlus);
		

};

extern vector<CPerso*> Personnages;


